// NOVLIB.CH V2.1
//
// by Goth
//

#define OT_WILD                         -1
#define OT_UNKNOWN                       0
#define OT_USER                          1
#define OT_USER_GROUP                    2
#define OT_PRINT_QUEUE                   3
#define OT_FILE_SERVER                   4
#define OT_JOB_SERVER                    5
#define OT_GATEWAY                       6
#define OT_PRINT_SERVER                  7
#define OT_ARCHIVE_QUEUE                 8
#define OT_ARCHIVE_SERVER                9
#define OT_JOB_QUEUE                    10
#define OT_ADMINISTRATION               11
#define OT_NAS_SNA_GATEWAY              33
#define OT_REMOTE_BRIDGE_SERVER         36
#define OT_TIME_SYNCHRONIZATION_SERVER	45
#define OT_ARCHIVE_SERVER_DYNAMIC_SAP   46
#define OT_ADVERTISING_PRINT_SERVER     71
#define OT_BTRIEVE_VAP                  80
#define OT_PRINT_QUEUE_USER             83

#define KEYWORD                          1
#define KEYVALUE                         2

/* Account Functions */

#xtranslate IsAccount()                  => if( AccVer() == 1, .T., .F.)
#xtranslate UserAccBal(<expC>)           => ;
   ReadSet(<expC>,OT_USER,"ACCOUNT_BALANCE",1)
#xtranslate UserAccBal(<expC>,<expN>)    => ;
   ReadSet(<expC>,OT_USER,"ACCOUNT_BALANCE",1,<expN>)
#xtranslate UserAccLim(<expC>)           => ;
   ReadSet(<expC>,OT_USER,"ACCOUNT_BALANCE",2)
#xtranslate UserAccLim(<expC>,<expN>)    => ;
   ReadSet(<expC>,OT_USER,"ACCOUNT_BALANCE",2,<expN>)
#xtranslate AddAccServ(<expC>,<expN>)    => ;
  AddtoSet(FsName(),OT_FILE_SERVER,<expC>,<expN>,"ACCOUNT_SERVERS")
#xtranslate DelAccServ(<expC>,<expN>)    => ;
  DelFromSet(FsName(),OT_FILE_SERVER,<expC>,<expN>,"ACCOUNT_SERVERS")

/* Bindery Functions */

#xtranslate WriteSet(<expC1>,<expN2>,<expC3>,<expN4>,<expN5>) =>;
  ReadSet(<expC1>,<expN2>,<expC3>,<expN4>,<expN5>)

#xtranslate WriteProp(<expC1>,<expN2>,<expC3>,<expN4>,<expC5>) =>;
  ReadProp(<expC1>,<expN2>,<expC3>,<expN4>,<expC5>)

#xtranslate WritePByte(<expC1>,<expN2>,<expC3>,<expN4>,<expN5>) =>;
  ReadPByte(<expC1>,<expN2>,<expC3>,<expN4>,<expN5>)

#xtranslate UserName(<expN>)             => ObjectName(<expN>)
#xtranslate GroupName(<expN>)            => ObjectName(<expN>)
#xtranslate QueueName(<expN>)            => ObjectName(<expN>)

#xtranslate UserID(<expC>)               => ObjectID(<expC>,OT_USER)
#xtranslate GroupID(<expC>)              => ObjectID(<expC>,OT_USER_GROUP)
#xtranslate QueueID(<expC>)              => ObjectID(<expC>,OT_PRINT_QUEUE)
#xtranslate ServerID(<expC>)             => ObjectID(<expC>,OT_FILE_SERVER)

#xtranslate IsMember(<expC1>,<expC2>)    => ;
  IsInSet(<expC2>,OT_USER_GROUP,<expC1>,OT_USER,"GROUP_MEMBERS")
#xtranslate IsSuper(<expC>)              => ;
  IsInSet(<expC>,OT_USER,"SUPERVISOR",OT_USER,"SECURITY_EQUALS")
#xtranslate IsConsOp(<expC>)             => ;
  IsInSet(FSName(),OT_FILE_SERVER,<expC>,OT_USER,"OPERATORS")
#xtranslate IsQueueOP(<expC1>,<expC2>)   => ;
  IsInSet(<expC2>,OT_PRINT_QUEUE,<expC1>,OT_USER,"Q_OPERATORS")
#xtranslate IsQueueUsr(<expC1>,<expC2>)  => ;
  IsInSet(<expC2>,OT_PRINT_QUEUE,<expC1>,OT_USER,"Q_USERS")
#xtranslate IsManager(<expC>)            => ;
  IsInSet("SUPERVISOR",OT_USER,<expC>,OT_USER,"MANAGERS")

#xtranslate BindOpen()                   => if(Bindery(.T.)==.T.,.T.,.F.)
#xtranslate BindClose()                  => if(Bindery(.F.)==.F.,.T.,.F.)

#xtranslate UserDelete(<expC>)           => ObjectDel(<expC>,OT_USER)
#xtranslate GroupDel(<expC>)             => ObjectDel(<expC>,OT_USER_GROUP)
#xtranslate UserRename(<expC1>,<expC2>)  => ObjectRen(<expC1>,<expC2>,OT_USER)
#xtranslate GroupRen(<expC1>,<expC2>)    => ObjectRen(<expC1>,<expC2>,OT_USER_GROUP)

#xtranslate AddConsOp(<expC>)            => ;
  AddToSet(FSName(),OT_FILE_SERVER,<expC>,OT_USER,"OPERATORS")
#xtranslate AddSuper(<expC>)             => ;
  AddToSet(<expC>,OT_USER,"SUPERVISOR",OT_USER,"SECURITY_EQUALS")
#xtranslate AddQueueOp(<expC1>,<expC2>)  => ;
  AddToSet(<expC2>,OT_PRINT_QUEUE,<expC1>,OT_USER,"Q_OPERATORS")
#xtranslate AddQueUser(<expC1>,<expC2>)  => ;
  AddToSet(<expC2>,OT_PRINT_QUEUE,<expC1>,OT_USER,"Q_USERS")
#xtranslate AddManager(<expC>)           => ;
  AddToSet("SUPERVISOR",OT_USER,<expC>,OT_USER,"MANAGERS")
#xtranslate AddQueGrp(<expC1>,<expC2>)   => ;
  AddToSet(<expC2>,OT_PRINT_QUEUE,<expC1>,OT_USER_GROUP,"Q_USERS")
#xtranslate DelConsOp(<expC>)            => ;
  DelFromSet(FSName(),OT_FILE_SERVER,<expC>,OT_USER,"OPERATORS")
#xtranslate DelSuper(<expC>)             => ;
  DelFromSet(<expC>,OT_USER,"SUPERVISOR",OT_USER,"SECURITY_EQUALS")
#xtranslate DelQueueOp(<expC1>,<expC2>)  => ;
  DelFromSet(<expC2>,OT_PRINT_QUEUE,<expC1>,OT_USER,"Q_OPERATORS")
#xtranslate DelQueUser(<expC1>,<expC2>)  => ;
  DelFromSet(<expC2>,OT_PRINT_QUEUE,<expC1>,OT_USER,"Q_USERS")
#xtranslate DelManager(<expC>)           => ;
  DelFromSet("SUPERVISOR",OT_USER,<expC>,OT_USER,"MANAGERS")
#xtranslate DelQueGrp(<expC1>,<expC2>)   => ;
  DelFromSet(<expC2>,OT_PRINT_QUEUE,<expC1>,OT_USER_GROUP,"Q_USERS")

#xtranslate GrpMembers(<expC>,<expN>)    => ;
  ObjectName(ReadSet(<expC>,OT_USER_GROUP,"GROUP_MEMBERS",<expN>),-1)
#xtranslate UserGrps(<expC>,<expN>)      => ;
  ObjectName(Readset(<expC>,OT_USER,"GROUPS_I'M_IN",<expN>),-1)
#xtranslate ConsOps(<expC>,<expN>)       => ;
  ObjectName(ReadSet(<expC>,OT_FILE_SERVER,"OPERATORS",<expN>),-1)
#xtranslate QueueOps(<expC>,<expN>)      => ;
  ObjectName(ReadSet(<expC>,OT_PRINT_QUEUE,"Q_OPERATORS",<expN>),-1)
#xtranslate QueueUsers(<expC>,<expN>)    => ;
  ObjectName(ReadSet(<expC>,OT_PRINT_QUEUE,"Q_USERS",<expN>),-1)
#xtranslate Managers(<expN>)             => ;
  ObjectName(ReadSet("SUPERVISOR",OT_USER,"MANAGERS",<expN>),-1)
#xtranslate SetPass(<expC1>,<expC2>,<expN>)     => ;
  PassChange(<expC1>,<expC2>,<expN>)


/* Directory Functions */

#xtranslate DirAddUser(<expN1>,<expC>,<expN2>)  => ;
  DirAddObj(<expN1>,<expC>,<expN2>)
#xtranslate DirAddGrp(<expN1>,<expC>,<expN2>)   => ;
  DirAddObj(<expN1>,<expC>,<expN2>)
#xtranslate DirDelUser(<expN>,<expC>)           => ;
  DirDelObj(<expN>,<expC>)
#xtranslate DirDelGrp(<expN>,<expC>)            => ;
  DirDelObj(<expN>,<expC>)
#xtranslate FileAddUsr(<expN1>,<expC>,<expN2>)  => ;
  DirAddObj(<expN1>,<expC>,<expN2>)
#xtranslate FileAddGrp(<expN1>,<expC>,<expN2>)  => ;
  DirAddObj(<expN1>,<expC>,<expN2>)
#xtranslate GetCurDrv()                  => CurrDrive()
#xtranslate SetCurDrv( <exp1> )          => CurrDrive( <exp1> )
#xtranslate FileDelUsr(<expN>,<expC>)    => DirDelObj(<expN>,<expC>)
#xtranslate FileDelGrp(<expN>,<expC>)    => DirDelObj(<expN>,<expC>)

/* Queue Management Functions */

#xtranslate QueueDel(<expC>)             => ;
  ObjectDel(<expC>,OT_PRINT_QUEUE)
#xtranslate QueueRen(<expC1>,<expC2>)    => ;
  ObjectRen(<expC1>,<expC2>,OT_PRINT_QUEUE)
#xtranslate CapQueueID( <expN> )         => CapQueue(<expN> )

/* Print Server Functions */

#xtranslate PSADDOPR(<expC1>,<expC2>)     => ;
  AddToSet(<expC2>,OT_PRINT_SERVER,<expC1>,OT_USER,"PS_OPERATORS")
#xtranslate PSADDUSR(<expC1>,<expC2>)   => ;
  AddToSet(<expC2>,OT_PRINT_SERVER,<expC1>,OT_USER,"PS_USERS")
#xtranslate PSDELOPR(<expC1>,<expC2>)     => ;
  DelFromSet(<expC2>,OT_PRINT_SERVER,<expC1>,OT_USER,"PS_OPERATORS")
#xtranslate PSDELUSR(<expC1>,<expC2>)   => ;
  DelFromSet(<expC2>,OT_PRINT_SERVER,<expC1>,OT_USER,"PS_USERS")
#xtranslate PSLSTOPR(<expC>,<expN>)         => ;
  ObjectName(IsInSet(<expC>,OT_PRINT_SERVER,"PS_OPERATORS",<expN>),-1)
#xtranslate PSLSTUSR(<expC>,<expN>)       => ;
  ObjectName(IsInSet(<expC>,OT_PRINT_SERVER,"PS_USERS",<expN>),-1)

/* Here follow the UDC's */

/*******************************************************************************
*                                                                              *
*   COMMAND NAME: ATTACH                                                       *
*    DESCRIPTION: Emulates syntax of Novell's ATTACH.EXE command line utility  *
*                                                                              *
*  Copyright (C) 1992 ASM Inc       . All Rights Reserved.                     *
*                                                                              *
*******************************************************************************/

#xcommand ATTACH <(a)> [<(b)>] => NlAttach( <(a)>, <(b)> )


/*******************************************************************************
*                                                                              *
*   COMMAND NAME: SETPASS                                                      *
*    DESCRIPTION: Emulates syntax of Novell's SETPASS.EXE command line utility *
*                                                                              *
*  Copyright (C) 1992 ASM Inc       . All Rights Reserved.                     *
*                                                                              *
*******************************************************************************/

#xcommand SETPASS <(a)> <(b)> [<(c)>] => NlSetPass( <(a)>, <(b)>, <(c)> )


/*******************************************************************************
*                                                                              *
*   COMMAND NAME: LOGIN                                                        *
*    DESCRIPTION: Emulates syntax of Novell's LOGIN.EXE command line utility   *
*                                                                              *
*  Copyright (C) 1992 ASM Inc       . All Rights Reserved.                     *
*                                                                              *
*******************************************************************************/

#xcommand LOGIN <(a)> <(b)> => NlLogin( <(a)>, <(b)> )


/*******************************************************************************
*                                                                              *
*   COMMAND NAME: LOGOUT                                                       *
*    DESCRIPTION: Emulates syntax of Novell's LOGOUT.EXE command line utility  *
*                                                                              *
*  Copyright (C) 1992 ASM Inc       . All Rights Reserved.                     *
*                                                                              *
*******************************************************************************/

#xcommand LOGOUT [<(a)>] => FSlogout( <(a)> )


/*******************************************************************************
*                                                                              *
*   COMMAND NAME: CLEAR STATION                                                *
*    DESCRIPTION: Emulates syntax of Novell's CLEAR STATION console utility    *
*                                                                              *
*  Copyright (C) 1992 ASM Inc       . All Rights Reserved.                     *
*                                                                              *
*******************************************************************************/

#xcommand CLEAR STATION <x> => ConnClear( <x> )


/*******************************************************************************
*                                                                              *
*   COMMAND NAME: GRANT                                                        *
*    DESCRIPTION: Emulates syntax of Novell's GRANT.EXE command line utility   *
*                                                                              *
*  Copyright (C) 1992 ASM Inc       . All Rights Reserved.                     *
*                                                                              *
*******************************************************************************/

#xcommand GRANT [<a:ALL>] ;
	       [<b:N,NO RIGHTS>] ;
	       [<c:S,SUPERVISORY>] ;
	       [<d:R,READ>] ;
	       [<e:W,WRITE>] ;
	       [<f:C,CREATE>] ;
	       [<g:E,ERASE>] ;
	       [<h:M,MODIFY>] ;
	       [<i:F,FILE SCAN>] ;
	       [<j:A,ACCESS CONTROL>];
         [FOR <(k)>] TO [<l:USER>] [<m:GROUP>] <(n)> ;
	 => ;
	 NlGrant( <(a)>, <(b)>, <(c)>, <(d)>, <(e)>, <(f)>, <(g)>, <(h)>,;
		  <(i)>, <(j)>, <(k)>, <(l)>, <(m)>, <(n)> )


/*******************************************************************************
*                                                                              *
*   COMMAND NAME: REMOVE                                                       *
*    DESCRIPTION: Emulates syntax of Novell's REMOVE.EXE command line utility  *
*                                                                              *
*  Copyright (C) 1992 ASM Inc       . All Rights Reserved.                     *
*                                                                              *
*******************************************************************************/

#xcommand REMOVE [<a:USER>] ;
		[<b:GROUP>] ;
		<(c)> FROM <(d)> ;
	 => ;
   DirDelObj( ObjectID( <(c)>, if( <(b)> == NIL, 1, 2 ) ), <(d)> )


/*******************************************************************************
*                                                                              *
*   COMMAND NAME: MAP                                                          *
*    DESCRIPTION: Emulates syntax of Novell's MAP.EXE command line utility     *
*                                                                              *
*  Copyright (C) 1992 ASM Inc       . All Rights Reserved.                     *
*                                                                              *
*******************************************************************************/

#xcommand MAP [<a:ROOT>] ;
	     [<b:INS,INSERT>] ;
			 [<c:DEL,DELETE,REM,REMOVE>] ;
			 [<d:N,NEXT>];
	     <(e)> ;
	 =>;
	 NlMap( <.a.>, <.b.>, <.c.>, <.d.>, <(e)> )


/*******************************************************************************
*                                                                              *
*   COMMAND NAME: MKDIR                                                        *
*    DESCRIPTION: Emulates syntax of DOS's MAKEDIR command line utility        *
*                                                                              *
*  Copyright (C) 1992 ASM Inc       . All Rights Reserved.                     *
*                                                                              *
*******************************************************************************/

#xcommand MKDIR <(a)> => CreateDir( <(a)>, 255 )

#xcommand MD <(a)> => CreateDir( <(a)>, 255 )

/*******************************************************************************
*                                                                              *
*   COMMAND NAME: RMDIR                                                        *
*    DESCRIPTION: Emulates syntax of DOS's REMOVEDIR command line utility      *
*                                                                              *
*  Copyright (C) 1992 ASM Inc       . All Rights Reserved.                     *
*                                                                              *
*******************************************************************************/

#xcommand RMDIR <(a)> => DeleteDir( <(a)> )

#xcommand RM <(a)> => DeleteDir( <(a)> )

/*******************************************************************************
*                                                                              *
*   COMMAND NAME: RENDIR                                                       *
*    DESCRIPTION: Emulates syntax of Novell's RENDIR command line utility      *
*                                                                              *
*  Copyright (C) 1992 ASM Inc       . All Rights Reserved.                     *
*                                                                              *
*******************************************************************************/

#xcommand RENDIR <(a)> <(b)> => RenameDir( <(a)>, <(b)> )


#xcommand SEND <(a)> TO <(b)> => MsgUser(Conns( <(b)> ), <(a)> )

#xcommand CASTON => MsgMode( 0 )

#xcommand CASTOFF [<a:ALL>] => MsgMode( if( <(a)> == NIL , 1, 2 ) )


/*******************************************************************************
*                                                                              *
*   COMMAND NAME: CAPTURE                                                      *
*    DESCRIPTION: Emulates syntax of Novell's CAPTURE.EXE command line utility *
*                                                                              *
*  Copyright (C) 1992 ASM Inc       . All Rights Reserved.                     *
*                                                                              *
*******************************************************************************/

#xcommand CAPTURE [S=<(a)>] [SERVER=<(a)>] [/S=<(a)>] [/SERVER=<(a)>] ;
		 [L=<(b)>] [LOCAL=<(b)>] [/L=<(b)>] [/LOCAL=<(b)>] ;
		 [P=<(c)>] [PRINTER=<(c)>] [/P=<(c)>] [/PRINTER=<(c)>] ;
		 [Q=<(d)>] [QUEUE=<(d)>] [/Q=<(d)>] [/QUEUE=<(d)>] ;
		 [F=<(e)>] [FORM=<(e)>] [/F=<(e)>] [/FORM=<(e)>] ;
		 [C=<(f)>] [COPIES=<(f)>] [/C=<(f)>] [/COPIES=<(f)>] ;
		 [TI=<(g)>] [TIMEOUT=<(g)>] [/TI=<(g)>] [/TIMEOUT=<(g)>] ;
		 [NAM=<(h)>] [NAME=<(h)>] [/NAM=<(h)>] [/NAME=<(h)>] ;
		 [T=<(i)>] [TABS=<(i)>] [/T=<(i)>] [/TABS=<(i)>] ;
		 [B=<(j)>] [BANNER=<(j)>] [/B=<(j)>] [/BANNER=<(j)>] ;
		 [<k:K,KEEP,/K,/KEEP>] ;
		 [<l:FF,FORMFEED,/FF,/FORMFEED>] ;
		 [<m:NFF,NOFORMFEED,/NFF,/NOFORMFEED>] ;
		 [<n:NT,NOTABS,/NT,/NOTABS>] ;
		 [<o:NB,NOBANNER,/NB,/NOBANNER>] ;
     [J=<(p)>] [JOB=<(p)>] [/J=<(p)>] [/JOB=<(p)>];
	 => ;
	 NlCapture( <(a)>, <(b)>, <(c)>, <(d)>, <(e)>, <(f)>, <(g)>, <(h)>, ;
        <(i)>, <(j)>, <(k)>, <(l)>, <(m)>, <(n)>, <(o)>, <(p)>)

/*******************************************************************************
*                                                                              *
*   COMMAND NAME: ENDCAP                                                       *
*    DESCRIPTION: Emulates syntax of Novell's ENDCAP.EXE command line utility  *
*                                                                              *
*  Copyright (C) 1992 ASM Inc       . All Rights Reserved.                     *
*                                                                              *
*******************************************************************************/

#xcommand ENDCAP [L=<(a)>] [LOCAL=<(a)>] [/L=<(a)>] [/LOCAL=<(a)>] ;
		[<b:ALL,/ALL>] [<c:C,CANCEL,/C,/CANCEL>] ;
		[CL=<(d)>] [CANCELLOCAL=<(d)>] [/CL=<(d)>] [/CANCELLOCAL=<(d)>] ;
	 => Nlendcap( <(a)>, <(b)>, <(c)>, <(d)> )

/* SysTime */

#xcommand SYSTIME <(a)> => NLSysTime( <(a)> )

/*******************************************************************************
*                                                                              *
*   COMMAND NAME: PURGE                                                        *
*    DESCRIPTION: Emulates syntax of Novell's PURGE.EXE command line utility   *
*                                                                              *
*  Copyright (C) 1992 ASM Inc       . All Rights Reserved.                     *
*                                                                              *
*******************************************************************************/

#xcommand PURGE [<(a)>] => NlPurge( <(a)> )

