#include "novlib.ch"

//
//
// By Goth & Malc
//
// Additional material by Dennis & Marvin at Lange Financial Corp.
//
//
//
//

FUNCTION NlAttach( a, b )

LOCAL nOffset,cServerName,cUserName,nServerNum,nOldServer

if ( "/" $ a )
  nOffset := at( "/", a )
  cServerName := substr( a, 1, nOffset - 1 )
  cUserName := substr( a, nOffset + 1 )
else
  cServerName := a
endif

if !(b == NIL)
  nOldServer := FSPrefID()
  nServerNum := FsAttach( cServerName )
  FSPrefID( nServerNum )
  FsLogin( cUserName, b )
  FSPrefID( nOldServer )
else
  FsAttach( cServerName )
endif

return NIL

//////////////////////////////////////////////////////////////////////////////

FUNCTION NlSetPass( a, b, c )

LOCAL nOldServer,nOffset,cServerName,cUserName

nOldServer := FsPrefID()

if !( c == NIL )
  if ( "/" $ a )
    nOffset := at( "/", a )
    cServerName := substr( a, 1, nOffset - 1 )
    cUserName := substr( a, nOffset + 1 )
  else
    cServerName := a
    cUserName = LoginName()
  endif
  FsPrefID( FsConnNo( cServerName ) )
  PassChange( cUserName, b, c )
else
  PassChange( LoginName(), a, b )
endif

FsPrefID( nOldServer )

return NIL

//////////////////////////////////////////////////////////////////////////////

FUNCTION NlLogin( a, b )

// commands not supported

// #, too much hassle, things like CAPTURE are handled anyway
// BREAK, you cant stop this one
// DOS BREAK, you can add this one yourself if you want
// PAUSE, whats the point
// PCCOMPATIBLE, it is
// REM[ARK], ignored anyway
// SHIFT, not sure what it does !


LOCAL nFileHandle,nFileLen,cText,nLenPointer,cFileName,cLine,nOffset
LOCAL lReturnVal,nLineOff,nOldPrefID, i, cDelDrive, cLoginTime, dLoginDate
PRIVATE cServer,cUser,cPassword,nOldServer,nNewServer
PRIVATE xHOUR,xHOUR24,xMINUTE,xSECOND,xAM_PM,xMONTH,xMONTH_NAME,xDAY
PRIVATE xDAY_OF_WEEK,xNDAY_OF_WEEK,xYEAR,xSHORT_YEAR,xLOGIN_NAME
PRIVATE xFULL_NAME,xSTATION,xP_STATION,xGREETING_TIME,xOS_VERSION,xOS
PRIVATE xMACHINE,xSMACHINE,xERROR_LEVEL,xMEMBER_OF,xPASSWORD_EXPIRES

// actually login //

if ( ( "/" $ a ) .OR. ( "\" $ a ) )
  nOffset := at( "/", a ) + at( "\", a )   // don't say anything !!
  cServer := substr( a, 1, nOffset - 1 )
  cUser := substr( a, nOffset + 1 )
else
  cUser := a
  cServer := ""
endif

if !( b == NIL )
  cPassword := b
else
  cPassword := ""
endif

if !( cServer == "" )
  if( nOldPrefID := FsAttach( cServer ) ) > 0
    FSPrefID( nOldPrefID )
    if !(FSLogin( cUser,cPassword ))
      return(.f.)
    endif
  else
    return(.f.)
  endif
else
  if !(FSLogin( cUser,cPassword ))
    return(.f.)
  endif
endif

// set up NetwareAlike variables //

cLoginTime := LoginTime()
dLoginDate := LoginDate()

xHOUR24        := substr(cLoginTime,1,2)
xMINUTE        := substr(cLoginTime,4,2)
xSECOND        := substr(cLoginTime,7,2)
xAM_PM         := if( val(xHOUR24) <= 12, "AM", "PM" )
xHOUR          := if( val(xHOUR24) <= 12, xHOUR24, str(val(xHOUR24) - 12, 2 ) )
xMONTH         := str(month(dLoginDate),2)
xMONTH_NAME    := cmonth(dLoginDate)
xDAY           := str(day(dLoginDate),2)
xDAY_OF_WEEK   := cdow(dLoginDate)
xNDAY_OF_WEEK  := dow(dLoginDate)
xYEAR          := str(year(dLoginDate),4)
xSHORT_YEAR    := right(xYEAR,2)
xLOGIN_NAME    := LoginName()
xFULL_NAME     := UserFName(LoginName())
xSTATION       := ltrim(str(ConnNo()))
xP_STATION     := NodeNumber()
xGREETING_TIME := "Good "+if( xAM_PM == "AM" , "morning", if( val(xHOUR24) > 17 ,"evening","afternoon"))
xOS            := WSOS()
xOS_VERSION    := WSOSVer()
xMACHINE       := WSLHard()
xSMACHINE      := WSSHard()

// look for system login script //

DirMap("SYS:PUBLIC",FindNetDrv() )
cFileName := FindNetDrv() + ":" + "\PUBLIC\NET$LOG.DAT"

if file( cFileName )

  nFileHandle := fopen( cFileName )

  if ferror() == 0

    nFileLen := fseek(nFileHandle,0,2)
    fseek(nFileHandle,0)

    cText := space(nFileLen)

    // might as well read the whole file in //

    if fread(nFileHandle,@cText,nFileLen) == nFileLen
      cText := alltrim(strtran(cText,chr(26),chr(13))) + chr(13)
    endif

    // here goes //

    do while (.t.)

      // find the end of the line //

      nOffset := at( chr(13), cText )

      if ( nOffset == 0 )
        exit
      endif

      cLine := upper(alltrim( substr( cText,1,nOffset-1) ))

      cText := alltrim( substr( cText, nOffset ) )

      if !NlParser( cLine )
         EXIT
      endif

    enddo

    fclose(nFileHandle)

  endif

endif

// look for user's login script //

cText := ""

cFileName := FindNetDrv() + ":" + "\MAIL\"+ltrim(strhex(LoginID()))+"\LOGIN"

if file( cFileName )

  nFileHandle := fopen( cFileName )

  if ferror() == 0

    nFileLen := fseek(nFileHandle,0,2)
    fseek(nFileHandle,0)

    cText := space(nFileLen)

    if fread(nFileHandle,@cText,nFileLen) == nFileLen
      cText := alltrim(strtran(cText,chr(26),chr(13))) + chr(13)
    endif

    // here goes //

    do while (.t.)

      // find the end of the line //

      nOffset := at( chr(13), cText )

      if ( nOffset == 0 )
        exit
      endif

      cLine := upper(alltrim( substr( cText,1,nOffset-1) ))

      cText := alltrim( substr( cText, nOffset ) )

      if !NlParser( cLine )
         EXIT
      endif

    enddo

    fclose(nFileHandle)

  endif

endif

return(.t.)

//////////////////////////////////////////////////////////////////////////////

FUNCTION ChkIfComparison( cLine )

LOCAL lPerformIF, cGroup
MEMVAR xLOGIN_NAME, xP_STATION, xSMACHINE

cLine := substr( cLine, at( "IF ", cLine ) + 3 )

DO CASE

  CASE ( '"%LOGIN_NAME"' == left( cLine, 13) )
       lPerformIF := ( xLOGIN_NAME $ cLine )

  CASE ( '"%P_STATION"' == left( cLine, 12) )
       lPerformIF := ( xP_STATION $ cLine )

  CASE ( 'MEMBER OF' == left( cLine, 9) )
       cGroup := substr(cLine,at('"',cLine)+1,;
                       (rat('"',cLine)) - (at('"',cLine)+1))
       lPerformIF := IsMember(LoginName(),cGroup)

  CASE ( '"%SMACHINE"' == left( cLine, 11) )
       lPerformIF := ( xSMACHINE $ cLine )

  OTHERWISE
       lPerformIF := .F.

ENDCASE

return lPerformIF

//////////////////////////////////////////////////////////////////////////////

FUNCTION NlParser( cLine )

LOCAL lMapRoot,lMapInsert,lMapDelete,lMapNext,nLPTNum
LOCAL cnt,strlen,item,nSord,cDord,cLowVar,cHighVar
STATIC lPerformIF, lIfStarted, aIfStack, cBatch

lIfStarted := iif( valtype(lIfStarted) == 'U', .F., lIfStarted )
lPerformIF := iif( valtype(lPerformIF) == 'U', .F., lPerformIF )

If lIfStarted
   DO CASE
      CASE ("END" == left( cLine, 3 ) )
         PopIF( @aIfStack )
         if empty(aIfStack)
            lPerformIF := .F.
            lIFStarted := .F.
         endif
         return .T.
      CASE ("ELSE" == left( cLine, 4 ) ) .and. lPerformIF
         lPerformIF := .F.
         return .T.
      CASE ("ELSE" == left( cLine, 4 ) ) .and. !lPerformIF
         lPerformIF := .T.
         return .T.
      CASE ("IF" == left( cLine, 2 ) ) .and. !lPerformIF
         Push( @aIfStack, cLine )
         return .T.
   ENDCASE
endif

if lPerformIF .OR. !lIfStarted
DO CASE

  CASE ( "REM" == left( cLine, 3 ) )

    // need this in case valid lines are rem'ed out


  CASE ("IF" == left( cLine, 2 ) )
     Push( @aIfStack, cLine )
     lPerformIF := ChkIfComparison( cLine )
     lIfStarted := .T.

/*  sorry !, when CA fix the bug in ALERT() this should work
  CASE ( "WRITE" $ cLine )

     cLine := substr( cLine, at( "WRITE ", cLine ) + 6 )
     if cLine <> '""'
        cLine := strtran( cLine, "%LOGIN_NAME", xLOGIN_NAME )
        cLine := strtran( cLine, "%GREETING_TIME", xGREETING_TIME )
        cLine := strtran( cLine, '"', '' )
        alert( cLine )
    endif
*/

  CASE ( "COMSPEC" $ cLine )

    nLineOff := at( "=", cLine )
    cLowVar := substr( cLine ,1 ,nLineOff-1)
    cHighVar := substr( cLine, nLineOff+1 )

    if ( nSord := val( substr( cLine, nLineOff+2 ))) > 0
      cDord := GetDrvFOrd( nSord )
      cHighVar := cDord + substr( cLine, at(":",cLine) )
    endif

    WsEnvVar( cLowVar, cHighVar )

  CASE ( "SET" $ left( cLine, 7 ) )  // in case of DOS SET

    cLine := substr( cLine, at( "SET ", cLine ) + 4 )
    cLine := strtran( cLine, chr(34) )
    nLineOff := at( "=", cLine )

    cLine := strtran( cLine, "%OS_VERSION", xOS_VERSION )
    cLine := strtran( cLine, "%OS", xOS )
    cLine := strtran( cLine, "%STATION", xSTATION )
    cLine := strtran( cLine, "%MACHINE", xMACHINE )
    cLine := strtran( cLine, "%SMACHINE", xSMACHINE )
    cLine := strtran( cLine, "%LOGIN_NAME", xLOGIN_NAME )

    WsEnvVar( substr( cLine ,1 ,nLineOff-1), substr( cLine, nLineOff+1 ) )

  CASE ( "DRIVE" == left( cLine, 5 ) )

    cLine = substr( cLine, at( "DRIVE ", cLine ) + 6, 1 )

    SetCurDrv( cLine )

  CASE ( "MAP" == left( cLine, 3 ) )

     cLine = substr( cLine, at( "MAP ", cLine ) + 4 )

     lMapRoot := .F.
     lMapInsert := .F.
     lMapDelete := .F.
     lMapNext := .F.

     DO CASE

       CASE ( "ROOT" == left( cLine, 4 ) )
         lMapRoot = .T.
       CASE ( "INS" == left( cLine, 3 ) )
         lMapInsert = .T.
       CASE ( ("DEL" == left( cLine, 3 )) .OR. ("REM" == left( cLine, 3 )) )
         lMapDelete = .T.
       CASE ( "NEXT" == left( cLine, 4 ) )
         lMapNext = .T.

     ENDCASE

     cLine := substr( cLine, at( " ", cLine ) + 1 )

     cLine := strtran( cLine, "%OS_VERSION", xOS_VERSION )
     cLine := strtran( cLine, "%OS", xOS )
     cLine := strtran( cLine, "%MACHINE", xMACHINE )
     cLine := strtran( cLine, "%SMACHINE", xSMACHINE )
     cLine := strtran( cLine, "%LOGIN_NAME", xLOGIN_NAME )

     NLMap( lMapRoot,lMapInsert,lMapDelete,lMapNext,cLine )

  CASE ( "ATTACH" == left( cLine, 6 ) ) // be careful, this assumes that the
                                        // users password is the same on all
                                        // servers

    cLine = substr( cLine, at( "ATTACH ", cLine ) + 7 )

    if at( "/", cLine ) > 0
      cServer = left( cLine, at( "/", cLine ) - 1 )
      cLine = substr( cLine, at( "/", cLine ) + 1 )
    endif

    if ( nNewServer := FSAttach( cServer )) > 0
      nOldServer = FSPrefID()
      FSPrefID( nNewServer )
      FSLogin( cUser, cPassword )
      FSPrefID( nOldServer )
    endif

  CASE ( "INCLUDE" $ cLine )

    // we'll let you work this out for yourself //

  CASE ( "CAPTURE" $ cLine )

     declare aitem[2,20]
     cLine = substr( cLine, at( "CAPTURE", cLine ) + 9 )

     strlen := len( cLine )
     itemcnt := 0
     cnt = 1
     substring = ""
     gotkey = .f.

     do while .t.

       char := substr(cLine,cnt,1)

       if ! (char $ "/ =")
         substring = substring + char
       endif

       cnt++

       if (cnt > strlen)
         char = " "   /* frig for end of string */
       endif

       if ((char $ "= " ) .and. len(substring) > 0)

         if (char = "=")

           itemcnt++
           aitem[KEYWORD,itemcnt] := substring
           gotkey := .t.
           substring = ""

         else  /* a space */

           if !(gotkey)

             itemcnt++
             aitem[KEYWORD,itemcnt] := substring
             /* might want to just in case there isn't one */
             aitem[KEYVALUE,itemcnt] := ""

           else

             aitem[KEYVALUE,itemcnt] := substring

           endif

           gotkey=.f.
           substring = ""

         endif

       endif

       if (cnt>strlen)
         exit
       endif

     enddo

     if( aitem[KEYWORD,1] == NIL )
       CapJob()
     elseif( (itemcnt := ascan( aitem[KEYWORD], "J" ) ) > 0 )
       CapJob( aitem[KEYVALUE,itemcnt] )
     else

       itemcnt := ascan( aitem[KEYWORD], "L" )

       nLPTNum := iif( itemcnt == 0, 1, val( aitem[KEYVALUE,itemcnt]) )

       itemcnt := ascan( aitem[KEYWORD], "S" )

       FSPrefid( iif( itemcnt == 0, FSPrefID(), FSConnNo(aitem[KEYVALUE,itemcnt]) ) )

       CapEnd( nLPTNum )

       if ( itemcnt := ascan( aitem[KEYWORD], "P" ) ) > 0
         CapPrnNo( nLPTNum, val( aitem[KEYVALUE,itemcnt]) )
       elseif ( itemcnt := ascan( aitem[KEYWORD], "Q" ) ) > 0
         CapQueue( nLPTNum, QueueID(aitem[KEYVALUE,itemcnt]) )
       endif

       if ( itemcnt := ascan( aitem[KEYWORD], "FF" ) ) > 0
         CapFrmFeed( nLPTNum, .T. )
         adel( aitem[KEYWORD], itemcnt )
         adel( aitem[KEYVALUE], itemcnt )
       else
         if ( itemcnt := ascan( aitem[KEYWORD], "FORMF" ) ) > 0
           CapFrmFeed( nLPTNum, .T. )
           adel( aitem[KEYWORD], itemcnt )
           adel( aitem[KEYVALUE], itemcnt )
         endif
       endif

       if ( itemcnt := ascan( aitem[KEYWORD], "F" ) ) > 0
         CapFrmName( nLPTNum,aitem[KEYVALUE,itemcnt] )
       endif

       if ( itemcnt := ascan( aitem[KEYWORD], "C" ) ) > 0
         CapCopies( nLPTNum, val(aitem[KEYVALUE,itemcnt]) )
       endif

       if ( itemcnt := ascan( aitem[KEYWORD], "TI" ) ) > 0
         CapTimeOut( nLPTNum, val(aitem[KEYVALUE,itemcnt])*18 )
         adel( aitem[KEYWORD], itemcnt )
         adel( aitem[KEYVALUE], itemcnt )
       endif

       if ( itemcnt := ascan( aitem[KEYWORD], "NAM" ) ) > 0
         BannerName( nLPTNum, aitem[KEYVALUE,itemcnt])
       endif

       if ( itemcnt := ascan( aitem[KEYWORD], "T" ) ) > 0
         TabFlag( nLPTNum, .T. )
         CapTabSize( nLPTNum, val(aitem[KEYVALUE,itemcnt]) )
       endif

       if ( itemcnt := ascan( aitem[KEYWORD], "B" ) ) > 0
         CapBanner( nLPTNum, aitem[KEYVALUE,itemcnt] )
       endif

       if ascan( aitem[KEYWORD], "K" ) > 0
         CapKeep( nLPTNum, .T. )
       endif

       if ( ( ascan( aitem[KEYWORD], "NFF" ) > 0 ) .OR. ( ascan( aitem[KEYWORD], "NOFORM" ) > 0 ) )
         CapFrmFeed( nLPTNum, .F. )
       endif

       if ( ( ascan( aitem[KEYWORD], "NT" ) > 0 ) .OR. ( ascan( aitem[KEYWORD], "NOTAB" ) > 0 ) )
         TabFlag( nLPTNum, .F. )
       endif

       if ( ( ascan( aitem[KEYWORD], "NB" ) > 0 ) .OR. ( ascan( aitem[KEYWORD], "NOBAN" ) > 0 ) )
         BannerFlag( nLPTNum, .F. )
       endif

       Capstart(nLPTNum)

     endif

  ENDCASE
endif

return .T.

//////////////////////////////////////////////////////////////////////////////

FUNCTION Push( aArray, xItem )

aArray := iif( valtype(aArray) == 'A', aArray, {} )
aadd( aArray, xItem)

return NIL

//////////////////////////////////////////////////////////////////////////////

FUNCTION PopIF( aArray )

LOCAL nLen, lReturn

if empty(aArray)
   lReturn := .F.
else
   nLen := len(aArray)
   lReturn := aArray[nLen]
   aDel(aArray, nLen)
   aSize(aArray, nLen - 1)
endif

return lReturn


//////////////////////////////////////////////////////////////////////////////

FUNCTION NlGrant( a, b, c, d, e, f, g, h, i, j, k, l, m, n )

LOCAL nRights, nObjectType, cPath, nOffset, cDrive, cFullPath

nRights := 0
nObjectType := 1

if !( a == NIL )      /* ALL */
  nRights := 511
elseif !( b == NIL )  /* NO RIGHTS */
  nRights := 0
else
  if !( c == NIL )    /* SUPERVISORY */
    nRights += 256
  endif
  if !( d == NIL )    /* READ */
    nRights += 1
  endif
  if !( e == NIL )    /* WRITE */
    nRights += 2
  endif
  if !( f == NIL )    /* CREATE */
    nRights += 8
  endif
  if !( g == NIL )    /* ERASE */
    nRights += 16
  endif
  if !( h == NIL )    /* MODIFY */
    nRights += 32
  endif
  if !( i == NIL )    /* FILE SCAN */
    nRights += 64
  endif
  if !( j == NIL )    /* ACCESS CONTROL */
    nRights += 128
  endif
endif

if !( k == NIL )
  cPath := k
  nOffset := at(":", cPath )
  if( nOffset > 0 )
   if( nOffset == 2 )
     cDrive = left( cPath, 1 )
     cPath := substr( cPath, 3 )
     cFullPath := GetNetPath( DirHandle( cDrive ) )
     cFullPath := StrTran( cFullPath, "/", "\" )
     if( left( cPath, 1 ) == "\" )
       nOffset := at( ":", cFullPath )
       cFullPath := left( cFullPath, nOffset )
       cPath := cFullPath + substr( cPath, 2 )
     else
       cPath := cFullPath + "\" + cPath
     endif
   endif
  else
    cPath := GetNetPath(DirHandle(CurrDrive()))+"\"+k
  endif
else
  cPath := GetNetPath(DirHandle(CurrDrive()))
endif

if !( m == NIL )
  nObjectType := 2
endif

return ( DirAddObj( ObjectID( n, nObjectType ), cPath, nRights ) )


FUNCTION NWPath( cDOSPath )

LOCAL nOffset, cDrive, cPath, cFullPath

cPath := cDOSPath

nOffset := at(":", cPath )

if( nOffset > 0 )
 if( nOffset == 2 )
   cDrive = left( cPath, 1 )
   cPath := substr( cPath, 3 )
   cFullPath := GetNetPath( DirHandle( cDrive ) )
   cFullPath := StrTran( cFullPath, "/", "\" )
   if( left( cPath, 1 ) == "\" )
     nOffset := at( ":", cFullPath )
     cFullPath := left( cFullPath, nOffset )
     cPath := cFullPath + substr( cPath, 2 )
   else
     cPath := cFullPath + "\" + cPath
   endif
 endif
else
  cPath := GetNetPath(DirHandle(CurrDrive()))+"\"+cDOSPath
endif

return( cPath )


//////////////////////////////////////////////////////////////////////////////

FUNCTION NlMap( a, b, c, d, e )

LOCAL nOldPrefID,cPath,cServer,nOffset,cDrive,nSearchOrd,nRetValue,nLastDrive

nOldPrefID := FSPrefID()

cPath := upper(alltrim(e))

if ( nOffset := at( ":",cPath ) ) > 0

  if (!( rat( ":",cPath ) > nOffset ) .or. ( d )) .and. !( c )
      cDrive := NextDrive()
  else
    cDrive := substr( cPath,1,nOffset-1 )
  endif

  if len( cDrive ) > 1

    nSearchOrd := val(right(cDrive,1))

    if left( cDrive, 1 ) == "S"

      cDrive := ""

    elseif left( cDrive, 1 ) == "*"

      nLastDrive := WSLocalDrv() + nSearchOrd
      nSearchOrd := 0

      cDrive := chr( nLastDrive + 64 )

    endif

  else

    nSearchOrd := 0

  endif

  nOffset := at( "=", cPath )

  cPath := substr( cPath,nOffset+1 )

else

  return( .f. )

endif

if ( nOffset := at( "/",cPath) ) > 0

  if at( ":",cPath ) > nOffset

    cServer := substr( cPath,1,nOffset-1 )

    if !(FsPrefID( FSConnNo( cServer ) ) > 0)

      return( .f. )

    endif

    cPath := substr( cPath,nOffset+1 )

  endif

endif


DO CASE

  CASE ( c )

    if nSearchOrd > 0
      DirSrchDel( nSearchOrd )
    else
      DirMapDel( cDrive )
    endif
    nRetValue := 0

  CASE ( a )

    if !( nSearchOrd > 0 )
      nRetValue := FakeRoot( cDrive, cPath )
    else
      nRetValue := 1
    endif

  CASE ( nSearchOrd > 0 )

    if ( b )
      nRetValue := MapSearch( "", cPath, nSearchOrd )
    else
      DirSrchDel( nSearchOrd )
      nRetValue := MapSearch( "", cPath, nSearchOrd )
    endif

  OTHERWISE

    DirMap( cPath, cDrive )

END CASE

FSPrefID( nOldPrefID )

return( nRetValue )

//////////////////////////////////////////////////////////////////////////////

FUNCTION NlCapture( a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p )

LOCAL nLPTNum

if ( d == NIL ) && ( c == NIL )
  if !( p == NIL )
    CapJob( upper( p ) )
  else
    CapJob()
  endif
  return(0)
endif


/*************************
* set local LPT port No. *
*************************/

nLPTNum := iif( b == NIL, 1, val(b) )

/********************************
* set up destination fileserver *
********************************/

FSPrefid( iif( a == NIL, FSPrefID(), FSConnNo(a) ) )

/******************************
* cancel any existing capture *
******************************/

CapEnd( nLPTNum )

/*****************************************
* check for destination printer or queue *
*****************************************/

if !( c == NIL )
  CapPrnNo( nLPTNum, val(c) )
elseif !( d == NIL )
  CapQueue( nLPTNum, QueueID(d) )
endif

/*****************
* check for form *
*****************/

if !( e == NIL )
  CapFrmName( nLPTNum, e )
endif

/*****************************
* check for number of copies *
*****************************/

if !( f == NIL )
  CapCopies( nLPTNum, val(f) )
endif

/********************
* check for timeout *
********************/

if !( g == NIL )
  CapTimeOut( nLPTNum, val(g)*18 )
endif

/************************
* check for banner name *
************************/

if !( h == NIL )
  BannerName( nLPTNum, h )
endif

/*********************
* check for tab size *
*********************/

if !( i == NIL )
  TabFlag( nLPTNum, .T. )
  CapTabSize( nLPTNum, val(i) )
endif

/*******************
* check for banner *
*******************/

if !( j == NIL )
  CapBanner( nLPTNum, j )
endif

/*****************
* check for keep *
*****************/

if !( k  == NIL )
  CapKeep( nLPTNum, .T. )
endif

/***********************
* check for form feeds *
***********************/

if !( l == NIL )
  CapFrmFeed( nLPTNum, .T. )
endif

/**************************
* check for no form feeds *
**************************/

if !( m == NIL )
  CapFrmFeed( nLPTNum, .F. )
endif

/********************
* check for no tabs *
********************/

if !( n == NIL )
  TabFlag( nLPTNum, .F. )
endif

/**********************
* check for no banner *
**********************/

if !( o == NIL )
  BannerFlag( nLPTNum, .F. )
endif

return( Capstart(nLPTNum) )


FUNCTION Nlendcap( a, b, c, d )

LOCAL nLPTNum

/*************************
* set local LPT port No. *
*************************/

nLPTNum := iif( a == NIL, iif( d == NIL, 1, val(d) ), val(a) )

if !( d == NIL )
  CapCancel( nLPTNum )
elseif !( c == NIL ) .and. !( b == NIL )
  CapCancel(1)
  CapCancel(2)
  CapCancel(3)
endif

if !( b == NIL )
  CapEnd(1)
  CapEnd(2)
  CapEnd(3)
else
  CapEnd( nLPTNum )
endif

return NIL

//////////////////////////////////////////////////////////////////////////////

FUNCTION NLSysTime( a )

LOCAL nOldServer, nNewServer

if !(a == NIL)
  nOldServer := FSPrefID()
  nNewServer := FsPrefID( a )
  TimeSync()
  FSPrefID( nOldServer )
else
  TimeSync()
endif

return NIL


//////////////////////////////////////////////////////////////////////////////

Function CapJob( cJobName )

LOCAL cFileName,nFileHandle,nFileLen,cText,nIndexOffset,nOffset
LOCAL cDefName,cServerName,cQueueName,nTabSize,nCopies,cFormName
LOCAL lNotifyFlag,nPServerID,cUserName,cBannerName,cDeviceName
LOCAL cModeName,lBannerFlag,lDataType,lFormFeed,nTimeOut,nPrinterNo
LOCAL lAutoEndCap,nOldPrefID

cFileName := FindNetDrv() + ":" + "\MAIL\"+;
                   ltrim(strhex(LoginID()))+"\PRINTCON.DAT"

if file( cFileName )                      // is there a printcon.dat file

  nFileHandle := fopen( cFileName )       // open it

  if ferror() == 0

    nFileLen := fseek(nFileHandle,0,2)    // get length
    fseek(nFileHandle,0)

    cText := space(nFileLen)              // create buffer

    if !( fread(nFileHandle,@cText,nFileLen) == nFileLen )  // read in file
      return( -1 )                                                // oops !
    endif

    // here goes //

    cDefName := substr( cText, 119, 32 )                    // skip header
    cDefName := left( cDefName, at( chr(0), cDefName ) -1 ) // default job

    if ( cJobName == NIL )                // if no job name passed
      cJobName := upper( cDefName )               // make it default job
    endif

    cText := substr( cText, 151 )         // start at begining of index

    if( nOffset := at( cJobName, upper( cText ) ) ) == 0   // find job
      cJobName := cDefName                // if not found make it default job
    endif

    nIndexOffset := bin2l(substr( cText, nOffset + 32, 4 ) )  // find offset

    cText := substr( cText, nIndexOffset - 149, 243 )    // get job

    cServerName := substr( cText, 1,  at( chr(0), cText ) - 1 )  // S=
    cText := substr( cText, 49 )
    cQueueName := substr( cText, 1, at( chr(0), cText ) -1 )     // Q=
    cText := substr( cText, 49 )
    nTabSize := bin2i( substr( cText, 1, 1 ) )                   // TAB=
    nCopies := bin2i( substr( cText, 2, 2 ) )                    // C=
    cText := substr( cText, 4 )
    cFormName := substr( cText, 1, at( chr(0), cText ) -1 )      // form
    cText := substr( cText, 41 )
    lNotifyFlag := if( substr( cText, 1, 1 ) != chr(0) , .T., .F. ) // notify
    nPserverID := bin2l( substr( cText, 2, 4 ) )                 // P server
    cText := substr( cText, 6 )
    cUserName := substr( cText, 1, at( chr(0), cText ) -1 )      // user
    cText := substr( cText, 14 )
    cBannerName := substr( cText, 1, at( chr(0), cText ) -1 )  // banner name
    cText := substr( cText, 14 )
    cDeviceName := substr( cText, 1, at( chr(0), cText ) -1 )    // device
    cText := substr( cText, 34 )
    cModeName := substr( cText, 1, at( chr(0), cText ) -1 )      // mode
    cText := substr( cText, 34 )
    lBannerFlag := if( substr( cText, 1, 1 ) != chr(0) , .T., .F. ) // banner
    lDataType := if( substr( cText, 2, 1 ) != chr(0) , .T., .F. )   // type
    lFormFeed := if( substr( cText, 3, 1 ) != chr(0) , .T., .F. )   // FF
    nTimeOut := bin2i( substr( cText, 4, 2 ) )                      // TI=
    nPrinterNo := val( chr( asc(substr( cText, 6, 1 )) + 48 ) )     // L=
    lAutoEndCap := if( substr( cText, 7, 1 ) != chr(0) , .T., .F. ) // auto

    fclose(nFileHandle)             // close file

    CapEnd( nPrinterNo )            // end existing capture

    nOldPrefID := FSPrefID()        // save old server

    FSPrefID( FSConnNo( cServerName ) )  // set new one

    CapQueue( nPrinterNo, QueueID( cQueueName ) )  // set queue

    if !( lDataType )
      TabFlag( nPrinterNo, .T. )                   // set tabs
      CapTabSize( nPrinterNo, nTabSize )
    else
      TabFlag( nPrinterNo, .F. )
    endif

    CapCopies( nPrinterNo, nCopies )               // set copies

    CapFrmName( nPrinterNo, cFormName )            // set form name

    NotifyFlag( nPrinterNo, lNotifyFlag )          // set notify

    BannerName( nPrinterNo, cUserName )          // set users name on banner

    if ( lBannerFlag )
      BannerFlag( nPrinterNo, .T. )
      CapBanner( nPrinterNo, cBannerName )        // set banner
    else
      BannerFlag( nPrinterNo, .F. )
    endif

    CapFrmFeed( nPrinterNo, !(lFormFeed) )       // set form feeds

    CapTimeOut( nPrinterNo, nTimeout * 18 )           // set time out

    CapAutoEnd( nPrinterNo, lAutoEndCap )           // set autoend

    CapStart( nPrinterNo )                       // start capture

    FSPrefID( nOldPrefID )                       // put back old server

  endif

else

  return( -2 )

endif

return( 0 )


//////////////////////////////////////////////////////////////////////////////

FUNCTION NlPurge(a)
return( Purge(a) )
