***************
* IsAccount() *
***************

FUNCTION IsAccount
  return( iif( AccVer() = 1, .T., .F. )  )


****************
* UserAccBal() *
****************

FUNCTION UserAccBal
  PARAMETERS cParam1,nParam2
  IF TYPE("nParam2") = "U"
    nBalance = ReadSet(cParam1,1,"ACCOUNT_BALANCE",1)
  ELSE
    nBalance = ReadSet(cParam1,1,"ACCOUNT_BALANCE",1,nParam2)
  ENDIF
  return( nBalance )


****************
* UserAccLim() *
****************

FUNCTION UserAccLim
  PARAMETERS cParam1,nParam2
  IF TYPE("nParam2") = "U"
    nLimit = ReadSet(cParam1,1,"ACCOUNT_BALANCE",2)
  ELSE
    nLimit = ReadSet(cParam1,1,"ACCOUNT_BALANCE",2,nParam2)
  ENDIF
  return( nLimit )


****************
* UserAccRes() *
****************


FUNCTION UserAccRes
  PARAMETERS cParam1,cParam2
  For x = 0 to 15
    if ObjectName(ReadSet(cParam1,1,"ACCOUNT_HOLDS",(x*2)),4) = cParam2
      nBalance = ReadSet(cParam1,1,"ACCOUNT_HOLDS",(x*2+1))
      exit
    else
      nBalance = 0
    endif
  next
  return( nBalance )


****************
* AddAccServ() *
****************

FUNCTION AddAccServ
  PARAMETERS cParam1
  return( AddToSet(FsName(),4,cParam1,1,"ACCOUNT_SERVERS") )


****************
* DelAccServ() *
****************

FUNCTION DelAccServ
  PARAMETERS cParam1
  return( DelFromSet(FsName(),4,cParam1,1,"ACCOUNT_SERVERS") )


********************
* UserName( ExpN ) *
********************

FUNCTION UserName
  PARAMETERS nParam1
  return( ObjectName( nParam1 ) )


*********************
* GroupName( ExpN ) *
*********************

FUNCTION GroupName
  PARAMETERS nParam1
  return( ObjectName( nParam1 ) )


*********************
* QueueName( ExpN ) *
*********************

FUNCTION QueueName
  PARAMETERS cParam1
  return( ObjectName( cParam1 ) )


******************
* UserID( ExpC ) *
******************

FUNCTION UserID
  PARAMETERS cParam1
  return( ObjectID( cParam1, 1 ) )


*******************
* GroupID( ExpC ) *
*******************

FUNCTION GroupID
  PARAMETERS cParam1
  return( ObjectID( cParam1, 2 ) )


*******************
* QueueID( ExpC ) *
*******************

FUNCTION QueueID
  PARAMETERS cParam1
  return( ObjectID( cParam1, 3 ) )


********************
* ServerID( ExpC ) *
********************

FUNCTION ServerID
  PARAMETERS cParam1
  return( ObjectID( cParam1, 4 ) )


******************************
* IsMember( ExpC1, ExpC2 )   *
******************************

FUNCTION IsMember
  PARAMETERS cParam1, cParam2
  return( IsInSet( cParam2, 2, cParam1, 1, "GROUP_MEMBERS" ) )


*******************
* IsSuper( ExpC ) *
*******************

FUNCTION IsSuper
  PARAMETERS cParam1
  return( IsInSet( cParam1, 1, "SUPERVISOR", 1, "SECURITY_EQUALS" ) )


******************************
* IsConsOp( ExpC1, ExpC2 )   *
******************************

FUNCTION IsConsOp
  PARAMETERS cParam1
  return( IsInSet( FSName(), 4, cParam1, 1, "OPERATORS" ) )


*****************************
* IsQueueOp( Expc1, Expc2 ) *
*****************************

FUNCTION IsQueueOp
  PARAMETERS cParam1, cParam2
  return( IsInSet( cParam2, 3, cParam1, 1, "Q_OPERATORS" ) )


******************************
* IsQueueUsr( Expc1, Expc2 ) *
******************************

FUNCTION IsQueueUsr
  PARAMETERS cParam1, cParam2
  return( IsInSet( cParam2, 3, cParam1, 1, "Q_USERS" ) )


******************************
* IsManager( expc )          *
******************************

FUNCTION IsManager
  PARAMETERS cParam1
  return( IsInSet( "SUPERVISOR", 1, cParam1, 1, "MANAGERS" ) )


**************
* BindOpen() *
**************

FUNCTION BindOpen
  return( if(Bindery( .T. ), .T., .F.) )


*************
* BindClose *
*************

FUNCTION BindClose
  return( if(Bindery( .F. ), .T., .F.) )


**********************
* UserDelete( Expc ) *
**********************

FUNCTION UserDelete
  PARAMETERS cParam1
  return( ObjectDel( cParam1, 1 ) )


**********************
* GroupDel( Expc )   *
**********************

FUNCTION GroupDel
  PARAMETERS cParam1
  return( ObjectDel( cParam1, 2 ) )


******************************
* UserRename( Expc1, Expc2 ) *
******************************

FUNCTION UserRename
  PARAMETERS cParam1, cParam2
  return( ObjectRen( cParam1, cParam2, 1 ) )


******************************
* GroupRen( Expc1, Expc2 )   *
******************************

FUNCTION GroupRen
  PARAMETERS cParam1, cParam2
  return( ObjectRen( cParam1, cParam2, 2 ) )


*****************************
* AddConsOp( Expc1, Expc2 ) *
*****************************

FUNCTION AddConsOp
  PARAMETERS cParam1, cParam2
  return( AddToSet( cParam2, 4, cParam1, 1, "OPERATORS" ) )


*****************************
* AddSuper( Expc1 )         *
*****************************

FUNCTION AddSuper
  PARAMETERS cParam1
  return( AddToSet( cParam1, 1, "SUPERVISOR", 1, "SECURITY_EQUALS" ) )


******************************
* AddQueueOp( Expc1, Expc2 ) *
******************************

FUNCTION AddQueueOp
  PARAMETERS cParam1, cParam2
  return( AddToSet( cParam2, 3, cParam1, 1, "Q_OPERATORS" ) )


******************************
* AddQueUser( Expc1, Expc2 ) *
******************************

FUNCTION AddQueUser
  PARAMETERS cParam1, cParam2
  return( AddToSet( cParam2, 3, cParam1, 1, "Q_USERS" ) )


*****************************
* AddQueGrp( Expc1, Expc2 ) *
*****************************

FUNCTION AddQueGrp
  PARAMETERS cParam1, cParam2
  return( AddToSet( cParam2, 3, cParam1, 2, "Q_USERS" ) )


***********************
* AddManager( Expc1 ) *
***********************

FUNCTION AddManager
  PARAMETERS cParam1
  return( AddToSet( "SUPERVISOR", 1, cParam1, 1, "MANAGERS" ) )


*****************************
* DelConsOp( Expc1, Expc2 ) *
*****************************

FUNCTION DelConsOp
  PARAMETERS cParam1, cParam2
  return( DelFromSet( cParam2, 4, cParam1, 1, "OPERATORS" ) )


*****************************
* DelSuper( Expc1 )         *
*****************************

FUNCTION DelSuper
  PARAMETERS cParam1
  return( DelfromSet( cParam1, 1, "SUPERVISOR", 1, "SECURITY_EQUALS" ) )


******************************
* DelQueueOp( Expc1, Expc2 ) *
******************************

FUNCTION DelQueueOp
  PARAMETERS cParam1, cParam2
  return( DelFromSet( cParam2, 3, cParam1, 1, "Q_OPERATORS" ) )


******************************
* DelQueUser( Expc1, Expc2 ) *
******************************

FUNCTION DelQueUser
  PARAMETERS cParam1, cParam2
  return( DelFromSet( cParam2, 3, cParam1, 1, "Q_USERS" ) )


*****************************
* DelQueGrp( Expc1, Expc2 ) *
*****************************

FUNCTION DelQueGrp
  PARAMETERS cParam1, cParam2
  return( DelFromSet( cParam2, 3, cParam1, 2, "Q_USERS" ) )


***********************
* DelManager( Expc1 ) *
***********************

FUNCTION DelManager
  PARAMETERS cParam1
  return( DelFromSet( "SUPERVISOR", 1, cParam1, 1, "MANAGERS" ) )


****************************
* GrpMembers( Expc, ExpN ) *
****************************

FUNCTION GrpMembers
  PARAMETERS cParam1, nParam2
  return( ObjectName(ReadSet( cParam1, 2, "GROUP_MEMBERS", nParam2 ), -1 ) )


****************************
* UserGrps( Expc, ExpN )   *
****************************

FUNCTION UserGrps
  PARAMETERS cParam1, nParam2
  return( ObjectName(ReadSet( cParam1, 1, "GROUPS_I'M_IN", nParam2 ), -1 ) )


****************************
* ConsOps( Expc, ExpN )    *
****************************

FUNCTION ConsOps
  PARAMETERS cParam1, nParam2
  return( ObjectName(ReadSet( cParam1, 4, "OPERATORS", nParam2 ), -1 ) )


****************************
* QueueOps( Expc, ExpN )   *
****************************

FUNCTION QueueOps
  PARAMETERS cParam1, nParam2
  return( ObjectName(ReadSet( cParam1, 3, "Q_OPERATORS", nParam2 ), -1 ) )


*******************************
* QueueUsers( Expc, ExpN )    *
*******************************

FUNCTION QueueUsers
  PARAMETERS cParam1, nParam2
  return( ObjectName(ReadSet( cParam1, 3, "Q_USERS", nParam2 ), -1 ) )


*******************************
* Managers( ExpN )            *
*******************************

FUNCTION Managers
  PARAMETERS cParam1
  return( ObjectName(ReadSet( "SUPERVISOR", 1, "MANAGERS", nParam2 ), -1 ) )

*******************************************************
* WriteSet( ExpC, ExpN, expC, ExpN, ExpN )            *
*******************************************************

FUNCTION WriteSet
  PARAMETERS cParam1,nParam2,cParam3,nParam4,nParam5
  return( ReadSet( cParam1, nParam2, cParam3, nParam4, nParam5 ) )

********************************************************
* WriteProp( ExpC, ExpN, expC, ExpN, ExpN )            *
********************************************************

FUNCTION WriteProp
  PARAMETERS cParam1,nParam2,cParam3,nParam4,nParam5
  return( ReadProp( cParam1, nParam2, cParam3, nParam4, nParam5 ) )

*********************************************************
* WritePByte( ExpC, ExpN, expC, ExpN, ExpN )            *
*********************************************************

FUNCTION WritePByte
  PARAMETERS cParam1,nParam2,cParam3,nParam4,nParam5
  return( ReadPByte( cParam1, nParam2, cParam3, nParam4, nParam5 ) )


**************
* DirAddUser *
**************

FUNCTION DirAddUser
  PARAMETERS nParam1, cParam2, nParam3
  return( DirAddObj( nParam1, cParam2, nParam3 ) )


*************
* DirAddGrp *
*************

FUNCTION DirAddGrp
  PARAMETERS nParam1, cParam2, nParam3
  return( DirAddObj( nParam1, cParam2, nParam3 ) )


***************
* FileAddUser *
***************

FUNCTION FileAddUser
  PARAMETERS nParam1, cParam2, nParam3
  return( DirAddObj( nParam1, cParam2, nParam3 ) )


**************
* FileAddGrp *
**************

FUNCTION FileAddGrp
  PARAMETERS nParam1, cParam2, nParam3
  return( DirAddObj( nParam1, cParam2, nParam3 ) )


**************
* DirDelUser *
**************

FUNCTION DirDelUser
  PARAMETERS nParam1, cParam2
  return( DirDelObj( nParam1, cParam2 ) )


*************
* DirDelGrp *
*************

FUNCTION DirDelGrp
  PARAMETERS nParam1, cParam2
  return( DirDelObj( nParam1, cParam2 ) )


*************
* GetCurDrv *
*************

FUNCTION GetCurDrv
  return( CurrDrive() )


*************
* SetCurDrv *
*************

FUNCTION SetCurDrv
  PARAMETERS nParam1
  return( CurrDrive( nParam1 ) )

***************
* FileDelUser *
***************

FUNCTION FileDelUser
  PARAMETERS nParam1, cParam2
  return( DirDelObj( nParam1, cParam2 ) )


**************
* FileDelGrp *
**************

FUNCTION FileDelGrp
  PARAMETERS nParam1, cParam2
  return( DirDelObj( nParam1, cParam2 ) )


**********************
* QueueDel( Expc )   *
**********************

FUNCTION QueueDel
  PARAMETERS cParam1
  return( ObjectDel( cParam1, 3 ) )


******************************
* QueueRen( Expc1, Expc2 )   *
******************************

FUNCTION QueueRen
  PARAMETERS cParam1, cParam2
  return( ObjectRen( cParam1, cParam2, 3 ) )


***************************
* PSADDOPR( Expc1, Expc2 ) *
***************************

FUNCTION PSADDOPR
  PARAMETERS cParam1, cParam2
  return( AddToSet( cParam2, 7, cParam1, 1, "PS_OPERATORS" ) )


*****************************
* PSADDUSR( Expc1, Expc2 ) *
*****************************

FUNCTION PSADDUSR
  PARAMETERS cParam1, cParam2
  return( AddToSet( cParam2, 7, cParam1, 1, "PS_USERS" ) )


***************************
* PSDELOPR( Expc1, Expc2 ) *
***************************

FUNCTION PSDELOPR
  PARAMETERS cParam1, cParam2
  return( DelFromSet( cParam2, 7, cParam1, 1, "PS_OPERATORS" ) )


*****************************
* PSDELUSR( Expc1, Expc2 ) *
*****************************

FUNCTION PSDELUSR
  PARAMETERS cParam1, cParam2
  return( DelFromSet( cParam2, 7, cParam1, 1, "PS_USERS" ) )


**************************
* PSLSTOPR( Expc, ExpN )    *
**************************

FUNCTION PSLSTOPR
  PARAMETERS cParam1, nParam2
  return( ObjectName(IsInSet( cParam1, 4, "PS_OPERATORS", nParam2 ), -1 ) )


****************************
* PSLSTUSR( Expc, ExpN )    *
****************************

FUNCTION PSLSTUSR
  PARAMETERS cParam1, nParam2
  return( ObjectName(IsInSet( cParam1, 4, "PS_USERS", nParam2 ), -1 ) )

