
* BindDump.prg - Demo for NOVLIB V2.0 bindery functions.
* Copyright (c) 1992, ASM Inc Ltd.
* Written by Ian Hill.

#include "novlib.ch"

external ObjectSec,PropSec,ObjectFlag,PropFlag,ReadSet,Objectname,ReadPByte,ReadProp

PUBLIC aBindTypes := { ;
                        "USERS",;
                        "USER GROUPS",;
                        "PRINT QUEUES",;
                        "FILE SERVERS",;
                        "JOB SERVERS",;
                        "GATEWAYS",;
                        "PRINT SERVERS",;
                        "ARCHIVE QUEUES",;
                        "ARCHIVE SERVERS",;
                        "JOB QUEUES";
                      }

PUBLIC nObjectType,cObjectName,cPropName,cDestSet,nObjectID
PUBLIC cCmdLine1,cCmdLine2,cCmdLine3,cCmdLine4,cCmdLine5
PUBLIC nStart,nFinish,cSearchName,aMode
PUBLIC lt,lp,lf,lv,ll

parameters cCmdLine1,cCmdLine2,cCmdLine3,cCmdLine4,cCmdLine5

la := iif( PCOUNT() == 0 ,.T.,.F. )

lt := iif( WasPassed("T") ,.T.,.F.)
lp := iif( WasPassed("P") ,.T.,.F.)
lf := iif( WasPassed("F") ,.T.,.F.)
lv := iif( WasPassed("V") ,.T.,.F.)
ll := iif( WasPassed("L") ,.T.,.F.)


if lf .or. la
  set(_SET_PRINTFILE,"BindDump.Dat")
  set(_SET_PRINTER,.T.)
endif

if lp
  set(_SET_PRINTER,.T.)
endif

clear
? "BindDump.exe, CopyRight (c) 1992, ASM Inc.  All Rights Reserved"
?
? "Written by Ian Hill."
?
?
if ( WasPassed("?") )
  ? "Usage: BindDump <options>"
  ?
  ? "Options: /P = Echo to printer             /F = Echo to file BindDump.Dat"
  ? "         /T = Include Trustee assignments /L = Include Login scripts"
  ? "         /V = Include Properties and their values"
  ? "         /? = Help"
  ?
  ? "Example: BindDump /F /V /T /L"
  ?
  ? "         Will create a file called BindDump.Dat, containing a list of"
  ? "         the complete contents of the Bindery Files including all the"
  ? "         properties and their values, and directory trustee lists."
  ? "         To run this program, you should be logged in as Supervisor."
  ?
  quit
endif
if ConnNo() == 0
  ? "Error, not connected to a Novell Network"
  quit
endif


nStart := 1
nFinish := 101
cSearchName := "*"

? "Bindery contents and Trustee assignment listing"
? "for Fileserver",FSName(),"running NetWare version",NWVersion()
?
use prop
index on Name to prop
go top

aMode :=array(2,lastrec())

do while !eof()
  aMode[1,recno()] := alltrim(Name)
  aMode[2,recno()] := alltrim(Format)
  skip
enddo

for nObjectType = nStart to nFinish
  BindGet()
next
? replicate(chr(240),80)
Set Printer Off
return



FUNCTION BindGet()
LOCAL cTitle,cOptions,aBindList,nCounter, nObjectFlag, nObjectSec

aBindList := {}

cObjectName := BindSearch( cSearchName, nObjectType )

do while !empty( cObjectName )

  aadd( aBindList, cObjectName )
  cObjectName := BindSearch()

enddo

cTitle := {|| QOut(replicate("=",79)), QOut("BINDERY OBJECT TYPE:",;
              " "+ltrim(str(nObjectType))+" ",;
              iif(nObjectType < 11,aBindTypes[nObjectType],"UNKNOWN")),;
              cTitle := {||NIL},NIL}

cOptions := {|| iif( lv .or. la, Properties(),NIL),;
                iif( lt .or. la, Trustees(),NIL),;
                iif( ll .or. la, ReadLogin( nObjectID, nObjectType ),NIL)}

nCounter = 1

do while ( nCounter <= len( aBindList ) )
  eval( cTitle )
  cObjectName := aBindList[nCounter]
  nObjectFlag := ObjectFlag(cObjectName,nObjectType)
  nObjectSec := ObjectSec(cObjectName,nObjectType)
  nObjectID := ObjectID(cObjectName,nObjectType)
  ? replicate("-",79)
  ?
  ? "Bindery Object Name:",cObjectname
  ? "Bindery Object ID  :",ltrim(strhex(nObjectID))
  ? "Static/Dynamic Flag:",Flags(nObjectFlag)
  ? "Object Security    :",SecurityCheck(nObjectSec)
  ?
  eval( cOptions )
  nCounter++
enddo

return NIL




FUNCTION SecurityCheck( cType )
LOCAL cSecString,cSecurity
LOCAL cRights := {;
                    "Anyone ",;
                    "Logged ",;
                    "Object ",;
                    "Supervisor ",;
                    "NetWare ";
                 }
cSecurity := ltrim(strhex(cType))
cSecString := cRights[val(right(cSecurity,1))+1]+"Read, "+;
              cRights[val(left(cSecurity,1))+1]+"Write"
return cSecString




FUNCTION Flags( cType )
LOCAL cFlagTypes := {;
                      "(Static)(Item)",;
                      "(Dynamic)(Item)",;
                      "(Static)(Set)",;
                      "(Dynamic)(Set)";
                    }
return cFlagTypes[cType+1]




FUNCTION WasPassed( cTestPar )
LOCAL cElement,nCounter := 0,lRetVal := .F.
do while ( ++nCounter < 6 )
  cElement := "cCmdLine"+str(nCounter,1)
  if ( valtype( &cElement. ) != "U" ) .and. (cTestPar $ upper(&cElement.))
    lRetVal := .T.
    exit
  endif
enddo
return ( lRetVal )



FUNCTION ReadLogin( uObject, nObjectType )
LOCAL nFileHandle,nFileLen,cLogScript,nLenPointer,cFileName

nObjectID := iif( valtype( uObject ) == "C",;
                  ObjectID( uObject,nObjectType ), uObject )

if nObjectType == 1
  cFileName := CurrDrive()+":\MAIL\"+ltrim(strhex(nObjectID))+"\LOGIN"
elseif( ( nObjectType == 4 ) .AND. ( FSName() == cObjectName ) )
  cFileName := CurrDrive()+":\PUBLIC\NET$LOG.DAT"
else
  return NIL
endif
if file( cFileName )
  nFileHandle := fopen( cFileName )
  if ferror() == 0
    nFileLen := fseek(nFileHandle,0,2)
    fseek(nFileHandle,0)
    cLogScript := space(nFileLen)
    if fread(nFileHandle,@cLogScript,nFileLen) == nFileLen
      cLogScript := alltrim(strtran(cLogScript,chr(26)))
      ? iif(nObjectType == 1,"User's","System"),"login script:"
      ?
      ? cLogScript
    else
      ? "Error reading File ",cFileName
    endif
    fclose(nFileHandle)
  else
    ? "Error opening file ",cFileName
  endif
else
  ? "Can't find file ",cFileName
endif
?
return NIL



FUNCTION Properties()
LOCAL nSetVal,nOffSet,cPropValue,nPointer,aPropList,nCounter,nMarker

aPropList := {}
nCounter := 1

if ObjectProp(cObjectName,nObjectType)
  ? "Properties:"
  ?

  cPropName := PropSearch( cObjectName, nObjectType, "*" )

  do while !empty( cPropName )

    aadd( aPropList, cPropName )
    cPropName := PropSearch()

  enddo

  do while ( nCounter <= len( aPropList ) )

    cPropName := aPropList[nCounter]
    ? padr(cPropName,15),"->",Flags(PropFlag(cObjectName, nObjectType, cPropName)),;
                              SecurityCheck(PropSec(cObjectName, nObjectType, cPropName))
    if PropHasVal(cObjectName, nObjectType, cPropName)
      ? "Values :"
      nMarker := 0
      nMarker := ascan( aMode[1], cPropName )
      if( nMarker == 0 )
        nMarker := ascan( aMode[1], "UNKNOWN" )
      endif
      nOffset := 1
      do while .T.
        cPropValue := eval(&(aMode[2,nMarker]),cObjectName,nObjectType,cPropName,nOffSet++)
        if !empty( cPropValue )
          if col() > 70 .or. nOffSet == 2
            qout( space(9)+cPropValue )
          else
            qqout( space(2)+cPropValue )
          endif
        else
          exit
        endif
      enddo
      ?
    endif
    nCounter++
  enddo
endif
return NIL




FUNCTION Trustees()
LOCAL cBindCode,nVolumeNum,cTrustPath
nVolumeNum := 0
? "Trustee Assignments:"
?
do while !empty( VolName(nVolumeNum) )
  cBindCode := {||l := ObjTrustee(nVolumeNum,nObjectID),;
                                cBindCode := {||ObjTrustee()},l}
  do while !empty( cTrustPath := eval( cBindCode ) )
    ? padr(cTrustPath,60),TrustMask(ObjAccess())
  enddo
  nVolumeNum++
enddo
?
return NIL
