
 ***************************************************************************
 * Network File Migration
 * Donald Reese & Goth
 * Allows a database of files to be built that meet certain conditions.
 * eg; collect files that haven't been modified in 120 days and exempt
 * .DBF,.EXE,.WK1, and .DAT files.
 *
 *  -Compile and Link with-
 *  clipper migrate /m/n/w/l
 *  blinker fi migrate lib novlib
 ***************************************************************************
 #include "novlib.ch"
 #include "inkey.ch"
 #include "directry.ch"
 
 FUNCTION main
 
 local nSubcnt := 1      ,;                      // number of sub-dirs
       currchk := 1      ,;
       cCurrDir          ,;                      // Current Directory
       aDirs := {}       ,;                      // array of sub directories
       nKey              ,;                      // var FOR inkey exiting
       nOfFiles          ,;                      // number of FILES
       cVolChoice        ,;                      // Choice of Volume
       i                 ,;                      // array element counter
       aFiles := {}      ,;                      // array FOR filenames
       cFname            ,;                      // Variable FOR owner ID
       dCDate            ,;
       cCTime            ,;
       dADate            ,;
       cATime            ,;
       cAName            ,;
       dAccess           ,;
       cIRMask


 local aDbf := { { "F_PATH"  , "C" , 80 , 0 } ,; // STRUCTURE FOR dFiles.dbf
                 { "F_NAME"  , "C" , 12 , 0 } ,;
                 { "F_SIZE"  , "N" , 10 , 0 } ,;
                 { "F_DATE"  , "D" ,  8 , 0 } ,;
                 { "F_TIME"  , "C" ,  8 , 0 } ,;
                 { "F_TYPE"  , "C" ,  1 , 0 } ,;
                 { "F_OWNER" , "C" , 12 , 0 } ,;
                 { "F_CDATE" , "D" ,  8 , 0 } ,;
                 { "F_CTIME" , "C" ,  8 , 0 } ,;
                 { "F_ADATE" , "D" ,  8 , 0 } ,;
                 { "F_ATIME" , "C" ,  8 , 0 } ,;
                 { "F_ANAME" , "C" , 12 , 0 } ,;
                 { "F_ACCESS", "D" ,  8 , 0 } ,;
                 { "F_IRMASK", "C" , 10 , 0 }}
 
 SET SCOREBOARD OFF
 CLS                                             // make a clean SCREEN
 IF !FILE("dfiles.dbf")                          // Does DATABASE exist?
    dbcreate("dFiles",aDbf)                      // CREATE it IF needed
 ENDIF
 USE dfiles EXCLUSIVE                            // no body ELSE but us
 ZAP                                             // clean it OUT
 BackGnd()
 MessPlace(3)
 COLOR (3)
 ChangeFS()
 aadd(aDirs,FSName()+'\'+PickVol()+':')          // First entry TO search
 cCurrDir = aDirs[1]                             // Start WITH the current
 progres(cCurrDir)
 aFiles := directory(cCurrDir,"D")               // LOAD up the FILES array
 @ 6,2 SAY "Start Time => "
 ?? TIME()                                       // timekeeping
 MessPlace(5)
 DO WHILE .t.                                    // DO forever
    pinwheel()                                   // spinning bar
    nOfFiles = LEN(aFiles)                       // how many FILES ?
    FOR i := 1 TO nOfFiles                       // process ALL array elements
       nKey := INKEY()                           // Check FOR ESCAPE KEY here
       IF nKey == K_ESC                          // because this LOOP is
          CLOSE ALL                              // tighter than the DO WHILE
          QUIT
       ENDIF
       pinwheel()                                // spinning bar
       IF aFiles[i][5] == "D"                    // Directory ??
          nSubcnt := nSubcnt + 1                 // increase sub-DIR COUNT
          aadd(aDirs,cCurrDir+aFiles[i][1]+"\")  // add the sub-DIR TO array
       ELSE
          /* This is where the code TO limit FILES selected would GO .
          eg; not place .dbf and .exe FILES in the DATABASE
          */
          dbappend()                       // new RECORD
          dfiles->f_path := cCurrDir       // add ALL the elements
          dfiles->f_name:= aFiles[i][1]
          dfiles->f_size :=aFiles[i][2]
          dfiles->f_date :=aFiles[i][3]
          dfiles->f_time :=aFiles[i][4]
          dfiles->f_type :=aFiles[i][5]
          cFname := UserName(FilOwnerID(SUBSTR(cCurrdir,(AT('\',cCurrDir)+1))+aFiles[i][1]))
          dfiles->f_owner:= cFname
          dCDate := FileDate()
          cCTime := FileTime()
          dADate := FilArcDate()
          cATime := FilArcTime()
          cAName := UserName(FileArcID())
          dAccess := FilAccDate()
          cIRMask := TrustMask(FileIRMask())
          dfiles->f_cdate := dCDate
          dfiles->f_ctime := cCTime
          dfiles->f_adate := dADate
          dfiles->f_atime := cATime
          dfiles->f_aname := cAName
          dfiles->f_access := dAccess
          dfiles->f_irmask := cIRMask


       ENDIF
    NEXT
    currchk := currchk+1
    IF currchk > nSubcnt
       EXIT
    ELSE
       cCurrDir = aDirs[currchk]
       aFiles := directory(cCurrDir,"D")
       progres(cCurrDir)
    ENDIF
    @ 8,2 SAY "      Time => "
    ?? TIME()
 ENDDO
 @ 7,2 SAY " Stop Time => "                      // Stop timing
 ?? TIME()
 ? RECCOUNT();?? " Files Processed"              // How many records?
 messplace(5)
 color(2)
 @ 23,05 say "Press any Key to continue "
 color(0)
 inkey(0)
 CLS
 RETURN nil                                      // Going Home!
 
 
 // Make this thing look just LIKE Novell's NDIR Utility
 FUNCTION pinwheel
 static pinwheel
 COLOR (2)
 IF pinwheel == NIL
    pinwheel := 1
 ENDIF
 DO CASE
 CASE pinwheel = 1
    setpos(23,3);devout( '| ' )
    pinwheel := 2
 CASE pinwheel = 2
    setpos(23,3);devout( '/ ' )
    pinwheel := 3
 CASE pinwheel = 3
    setpos(23,3);devout( '- ' )
    pinwheel := 4
 CASE pinwheel = 4
    setpos(23,3);devout( '\ ' )
    pinwheel := 1
 ENDCASE
 COLOR (0)
 RETURN nil
 
 FUNCTION ChangeFS
 LOCAL Servers[8],ServerNo,NewServer,screen1
 screen1 := savescreen(7,14,18,66)
 UserTitle()
 ExpBox(7,14,18,66,"Choose Fileserver to Process",.f.)
 MessPlace(1)
 FOR ServerNo = 1 TO 8
    IF FsPrefID(ServerNo) == ServerNo
       Servers[ServerNo] := padr(FSName(),24)
    ENDIF
 NEXT
 FSPrefID(1)
 MessPlace(3)
 COLOR (3)
 @ 10,16 TO 17,16
 IF (NewServer := achoice(10,17,17,65,Servers)) != 0
    FSPrefID(NewServer)
 ENDIF
 restscreen(7,14,18,66,screen1)
 RETURN NIL
 
 FUNCTION TITLE (cHeader)
 COLOR (2)
 @ 2,10 CLEAR TO 2,70
 @ 2,(80-LEN(cHeader))/2 SAY cHeader
 COLOR (0)
 RETURN NIL
 
 FUNCTION UserTitle
 TITLE ("User "+RTRIM(SUBSTR(LoginName(),1,15))+" on Fileserver "+RTRIM(SUBSTR(FsName(),1,15))+" Connection "+LTRIM(STR(ConnNo())))
 RETURN NIL
 
 FUNCTION COLOR (m_color)
 LOCAL colors := { ;
    {"bg/b,b/w","w/n,n/w"},;
    {"gr+/b,b/w","w+/n,n/w"},;
    {"b/bg,b/w","n/w,w/n"},;
    {"w+/b,b/w","w/n,n/w"},;
    {"r/bg","n/w,w/n"},;
    }
 
 SET (_SET_COLOR,colors[m_color+1][if(iscolor(),1,2)])
 RETURN NIL
 
 
 FUNCTION ExpBox(t,l,b,r,TITLE ,line,SELECT)
 LOCAL height, width, t1, l1, b1, r1
 COLOR (1)
 IF TYPE("select") = "U"
    height := b - t
    width := r - l
    t1 := t + (height / 2)
    l1 := l + (width / 2)
    b1 := b - (height / 2)
    r1 := r - (width / 2)
    DO WHILE t1-1 > t .OR. l1 > l
       @ t1,l1 CLEAR TO b1,r1
       @ t1,l1 TO b1,r1 DOUBLE
       IF t1-1 > t
          t1--
          b1++
       ENDIF
       IF l1 > l
          l1--
          r1++
       ENDIF
    ENDDO
    @ t,l CLEAR TO b,r
    IF line
       COLOR (3)
       @ t+3,l+2 TO b-1,l+2
       COLOR (1)
    ENDIF
    elseif (SELECT == .f.)
    COLOR (3)
 ENDIF
 @ t,l TO b,r double
 @ t+2,l+1 TO t+2,r-1 double
 @ t+2,l SAY CHR(204)
 @ t+2,r SAY CHR(185)
 @ t+1,l+((r-l-LEN(TITLE ))/2) SAY TITLE
 RETURN NIL
 
 FUNCTION PickVol(cVolChoice)
 local aVols := {},nCntr := 0,choice,buffer
 DO WHILE .t.
    IF LEN(TRIM(VolName(nCntr))) > 0
       aadd(aVols,VolName(nCntr))
       nCntr++
    ELSE
       nCntr++                            // Add the lines FOR the box
       EXIT
    ENDIF
 ENDDO
 buffer := savescreen(9,9,9+nCntr,23)
 @ 9,9 TO 9+nCntr,23 double
 @ 9,12 SAY "[Volume]"
 Choice := achoice(10,10,10+nCntr,22,aVols)
 IF Choice == 0                                   // User pressed ESCAPE
    Choice++                                      // instead of choosing
 ENDIF
 restscreen(9,9,9+nCntr,23,buffer)
 RETURN aVols[choice]
 
 
 FUNCTION MessPlace(MessNum,WaitForIt)
 
 LOCAL MessOpt := { {"Please wait......",""},;
    {"Press any key to continue......",""},;
    {CHR(24)+CHR(25)+" Move Cursor   "+CHR(17)+"Y Select Option","Esc=Exit"},;
    {"Enter a valid Novlib Function","Esc=Exit"},;
    {"                                                          ","Esc=Exit"},;
    {"Move Text","Esc=Exit"}}
 
 COLOR (2)
 @23,1 CLEAR TO 23,77
 @23,2 SAY MessOpt[MessNum][1]
 @23,70 SAY MessOpt[MessNum][2]
 IF (MessNum == 2 ) .and. (TYPE("WaitForIt") == "U")
    INKEY(0)
 ENDIF
 COLOR (0)
 RETURN NIL
 
 
 FUNCTION BackGnd
 LOCAL i
 COLOR (2)
 @ 0,0 CLEAR TO 3,79
 @ 0,0 TO 3,79
 COLOR (0)
 FOR i = 4 TO 21
    @ i,0 SAY REPLICATE(CHR(176),80)
 NEXT
 COLOR (2)
 @ 22,0 CLEAR TO 24,79
 @ 22,0 TO 24,79
 COLOR (4)
 @ 1,2 SAY "ASM Inc         ."
 COLOR (2)
 @ 1,38 SAY CDOW(DATE())+" "+STR(DAY(DATE()))+" "+CMONTH(DATE())+" "+;
    STR(YEAR(DATE()))
 @ 1,68 SAY TIME()
 COLOR (0)
 RETURN NIL
 
 FUNCTION progres(cCurrDir)
 MessPlace(5)
 COLOR (2)
 @ 23,05 SAY "Searching "+cCurrDir               // What directory is it?
 COLOR (0)
 RETURN nil
 
